unit stickup1;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, Menus, ExtCtrls, waissdcu, Buttons;
   
type
   TForm1 = class(TForm)
      Button1: TButton;
      Memo1: TMemo;
      PopupMenu1: TPopupMenu;
      Timer1: TTimer;
      About1: TMenuItem;
      N1: TMenuItem;
      CopyfromClipboard1: TMenuItem;
      PastetoClipboard1: TMenuItem;
      N2: TMenuItem;
      N3: TMenuItem;
      LoadTextFromFile1: TMenuItem;
      SaveTextToFile1: TMenuItem;
      N4: TMenuItem;
      OpenDialog1: TOpenDialog;
      SaveDialog1: TSaveDialog;
      Help1: TMenuItem;
      N5: TMenuItem;
      procedure Button1Click(Sender: TObject);
      procedure FormPaint(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormResize(Sender: TObject);
      procedure Exit1Click(Sender: TObject);
      procedure Memo1MouseDown(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState;
      X, Y: Integer);
      procedure Memo1MouseMove(Sender: TObject;
      Shift: TShiftState;
      X,
      Y: Integer);
      procedure Memo1MouseUp(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState;
      X, Y: Integer);
      procedure BitBtn1Click(Sender: TObject);
      procedure Timer1Timer(Sender: TObject);
      procedure N2Click(Sender: TObject);
      procedure CopyfromClipboard1Click(Sender: TObject);
      procedure PastetoClipboard1Click(Sender: TObject);
      procedure LoadTextFromFile1Click(Sender: TObject);
      procedure SaveTextToFile1Click(Sender: TObject);
      procedure About1Click(Sender: TObject);
      procedure Help1Click(Sender: TObject);
   private
      mx, my, mdown: integer;  // position where click occoured on memo for dragging
      { Private declarations }
      stuckto: Hwnd;
      mbool: bool;
      sx, sy: integer;  // diffrences where stuck on window
      winrec: trect;    // wwindow rectangle to check if window moved
      forewin: hwnd;  // check if this window is topmost
      mdwp: hdwp;
   public
      { Public declarations }
   end;
      
var
   Form1: TForm1;
   
implementation

uses about;

   {$R *.DFM}

   //------------------------------------------------------------------------------


procedure TForm1.Button1Click(Sender: TObject);
begin
   application.terminate;
end;

//------------------------------------------------------------------------------


procedure TForm1.FormPaint(Sender: TObject);
begin



   canvas.pen.color := $00007373;
   canvas.MoveTo(width - 1, height);
   canvas.LineTo(width - 1, 0);
   canvas.MoveTo(width - 1, height - 1);
   canvas.lineto(0, height - 1);


end;

//------------------------------------------------------------------------------


procedure TForm1.FormCreate(Sender: TObject);
begin
   height := 100;
   width := 150;
   form2.show;

end;

//---------------------------------------------------------

procedure TForm1.FormResize(Sender: TObject);
begin
   memo1.Height := height - 2;
   memo1.width := width - 2;
   memo1.top := 1;
   memo1.left := 1;

end;

//------------------------------------------------------------------------------


procedure TForm1.Exit1Click(Sender: TObject);
begin
   application.terminate;
end;




//------------------------------------------------------------------------------


procedure TForm1.Memo1MouseDown(Sender: TObject;
Button: TMouseButton;
Shift: TShiftState;
X, Y: Integer);
begin
   mx := x;                    // assign valu
   my := y;
   mdown := 1; // mouse is down so that mouse move can do it
   screen.cursor := crsize;
end;

//------------------------------------------------------------------------------


procedure TForm1.Memo1MouseMove(Sender: TObject;
Shift: TShiftState;
X,
Y: Integer);

var
   p: Tpoint;


begin
   if  mdown = 1 then
   begin

      getcursorpos(p);

      left := p.x - mx;
      top := p.y - my;

   end;
end;

//------------------------------------------------------------------------------



procedure TForm1.Memo1MouseUp(Sender: TObject;
Button: TMouseButton;
Shift: TShiftState;
X, Y: Integer);

var swnd, anwnd: hwnd;
   mrect: trect;

begin
   mdown := 0;
   screen.Cursor := crdefault;
   swnd := WindowFromPoint(Point(left - 1, top - 1));
   stuckto := GetTopParentWin(swnd); //call my function to find final top window


   getwindowrect(stuckto, mrect);

   sx := left - mrect.Left;
   sy := top - mrect.top;

   anwnd := GetForegroundWindow();
   if anwnd <> stuckto then
   begin
      anwnd := stuckto;
   end;


end;

//------------------------------------------------------------------------------


procedure TForm1.BitBtn1Click(Sender: TObject);

var mrect: trect;

begin
   getwindowrect(stuckto, mrect);

   left := mrect.Left + sx;
   top := mrect.top + sy;


end;

//------------------------------------------------------------------------------


procedure TForm1.Timer1Timer(Sender: TObject);

var
   mrect: trect;
   newnd: hwnd;



begin
   if iswindow(stuckto) = null then
      stuckto := GetDesktopWindow;


   if mdown = 1 then
      exit;
   if stuckto = 0 then
      exit;
   newnd := getforegroundwindow();

   getwindowrect(stuckto, mrect);

   if stuckto = getforegroundwindow then
   begin
      ;              // have to bring it before the top window

      setwindowpos(handle, hwnd_topmost, 0, 0, 0, 0, swp_nomove or swp_nosize or swp_noactivate);

   end;


   if (EqualRect(mrect, winrec) = false ) or  (getforegroundwindow = form1.Handle) then
      // parent got moved or activated so put him on top

begin
   winrec := mrect;


   left := mrect.Left + sx;
   top := mrect.top + sy;

   setwindowpos(handle, hwnd_topmost, 0, 0, 0, 0, swp_nomove or swp_nosize or swp_noactivate);

end;
if (stuckto <> getforegroundwindow()) and (stuckto <> form1.handle) then
   setwindowpos(handle, hwnd_notopmost, 0, 0, 0, 0, swp_nomove or swp_nosize or swp_noactivate);

if stuckto = getforegroundwindow then
   setwindowpos(handle, hwnd_topmost, 0, 0, 0, 0, swp_nomove or swp_nosize or swp_noactivate);

end;

//--------------------------------------------------------------------


procedure TForm1.N2Click(Sender: TObject);
begin
   Application.Terminate;
end;

//--------------------------------------------------------------------


procedure TForm1.CopyfromClipboard1Click(Sender: TObject);
begin
   memo1.PasteFromClipboard;
end;

//--------------------------------------------------------------------


procedure TForm1.PastetoClipboard1Click(Sender: TObject);
begin
   memo1.CopyToClipboard;
end;

//--------------------------------------------------------------------


procedure TForm1.LoadTextFromFile1Click(Sender: TObject);
begin
   if opendialog1.execute then
      memo1.Lines.LoadFromFile(opendialog1.FileName);

end;

//--------------------------------------------------------------------


procedure TForm1.SaveTextToFile1Click(Sender: TObject);
begin
   if savedialog1.execute then
      memo1.lines.SaveToFile(savedialog1.FileName);
end;


//--------------------------------------------------------------------



procedure TForm1.About1Click(Sender: TObject);
begin
   form2.Show;
end;

//--------------------------------------------------------------------


procedure TForm1.Help1Click(Sender: TObject);
begin
   showmessage('this is help')
end;

end.
